/*  commandir_send  Version 0.1
    Initial Release: Feb 9, 2011  
 */

#include "libcmdir.h"

extern unsigned int tx_bitmask;
extern char * send_filename;

void transmit_tx_char(char * tx_char)
{
  struct sendir * tx = NULL;
  tx = tx_char_2_struct(tx_char);
  if(tx)
  {
    tx->emitterMask = tx_bitmask;
    commandir_sendir(tx);
  }
}


int main(int argc, char **argv)
{
  char * tx_char = NULL;
  int x;
  unsigned int msDelay = 200;
  
  if(argc == 1)
  {
    printf("Send IR codes from CommandIR\n\n");
    printf("commandir_send [-dDELAY] [-eEMITTERNUM] FILENAME [FILENAME]...\n");
    printf("commandir_send [-dDELAY] -b000F FILENAME [FILENAME]...\n\n");
    printf("Examples:\n");
    printf("commandir_send -d500 -e3 amp_volup amp_volup\n");
    printf("commandir_send -b0F sa_power\n");
    return 0;
  }

  for(x=1; x<argc; x++)
  {
    if(argv[x][0] == '-')
    {
      switch(argv[x][1])
      {
        case 'e':
          // Emitter selection
          if(tx_bitmask)
          {
            printf("Cannot specify both -b and -e!\n");
            return -1;
          }
          // TODO: this should be checked for: 0x prefix, len(4), numbers only
          tx_bitmask = atoi(&argv[x][2]); 
          tx_bitmask = (0x01 << (tx_bitmask-1));
          break;
        case 'b':
          // hex tx_bitmask
          if(tx_bitmask)
          {
            printf("Cannot specify both -e and -b!\n");
            return -1;
          }
          tx_bitmask = convert_quad(&argv[x][2], strlen(&argv[x][2]));  
          break;
        case 'd':
          msDelay = atoi(&argv[x][2]);
          break;
        case 'r':
          // They're giving us raw codes on the Command Line
          printf("Raw codes - not implemented\n");
          return -1;
      }
    }
  }

  if(tx_bitmask == 0)
    tx_bitmask = 0xffffffff;
  
  if(tx_char == NULL)
  {
    for(x=1; x<argc; x++)
    {
      if(argv[x][0] != '-')
      {
        send_filename = argv[x];
        tx_char = load_file(argv[x]);
        if(tx_char)
        {
          transmit_tx_char(tx_char);
          free(tx_char);
          // Only pause if we have another signal to transmit:
          if(x < argc - 1)
            usleep(msDelay * 1000);
        }
      }
    }
  } else { 
    transmit_tx_char(tx_char);
  }
  
  return 0;
}

